%TABLE 7.5
%Unconstrained optimization routines M-file for Example 7.2

% File name: Example7_2
% Rosenbruck valley function with analytical gradient of the objective function

    clear

    x0 = [-1.2 1.0]';    % Set starting point

% Invoke unconstrained optimization routines

% 1. Nelder-Mead simplex method, "fminsearch"
% Set options: medium scale optimization and maximum number of function evaluations are specified
% 
   options = optimset('LargeScale', 'off', 'MaxFunEvals', 300);
   [x1, FunValue1, ExitFlag1, Output1] = fminsearch ('ObjAndGrad7_2', x0, options)

% 2. BFGS method, "fminunc", dafault option
% Set options: medium scale optimization, maximum number of function
% evaluation, gradient of objective function provided

   options = optimset('LargeScale', 'off', 'MaxFunEvals', 300, 'GradObj', 'on');
   [x2, FunValue2, ExitFlag2, Output2] = fminunc ('ObjAndGrad7_2', x0, options)

% 3. DFP method, "fminunc", HessUpdate = dfp
% Set options: medium scale optimization, maximum number of function evaluation,
% gradient of objective function provided, Hessian update of DFP is selected

   options = optimset('LargeScale', 'off', 'MaxFunEvals', 300, 'GradObj', 'on', 'HessUpdate', 'dfp');
   [x3, FunValue3, ExitFlag3, Output3] = fminunc ('ObjAndGrad7_2', x0, options)
